<?php

namespace FiloBlu\Orderstatus\Plugin\Sales\Model;

use FiloBlu\OrderStatus\Helper\Data;

class Order
{
    const DEBUG_LOG_ACTIVE = TRUE;

    /**
     * @var \Psr\Log\LoggerInterface $_logger
     */
    protected $_logger;

    /**
     * @var Data
     */
    protected $helper;

    /**
     * @param \Psr\Log\LoggerInterface $logger
     */
    public function __construct(
        \Psr\Log\LoggerInterface $logger,
        Data $helper
    ){
        $this->_logger = $logger;
        $this->helper = $helper;
    }

    public function beforeAddStatusHistory(
        \Magento\Sales\Model\Order $subject,
        $history
    ) {
        $fromStatus = $subject->getOrigData('status');
        $toStatus = $subject->getData('status');
        $hasInvoice = $subject->hasInvoices();

        if(!$this->helper->isValidStatusUpdate($fromStatus, $toStatus, $hasInvoice))
        {
            if (self::DEBUG_LOG_ACTIVE)
            {
                $this->_logger->addInfo("FiloBlu\OrderStatus\Plugin\Model: Status cannot be updated in payment_confirmed without invoice, order ".$subject->getIncrementId());
            }
            throw new \Magento\Framework\Exception\LocalizedException(__("Status update not allowed!"));
        }

        return [$history];
    }
}